// ^􉽊֐
unit main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Velthuis.BigIntegers, Velthuis.Bigdecimals,
  Vcl.StdCtrls, Vcl.ExtCtrls, Vcl.Buttons, Vcl.Imaging.pngimage, system.UITypes, complex_sub;

type
  TForm1 = class(TForm)
    izEdit: TLabeledEdit;
    zEdit: TLabeledEdit;
    ibEdit: TLabeledEdit;
    bEdit: TLabeledEdit;
    iaEdit: TLabeledEdit;
    aEdit: TLabeledEdit;
    epsEdit: TLabeledEdit;
    PrecisionEdit: TLabeledEdit;
    Memo1: TMemo;
    CalcBtn: TBitBtn;
    Image1: TImage;
    deltEdit: TLabeledEdit;
    BitBtn1: TBitBtn;
    procedure CalcBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
  private
    { Private 錾 }
    function inputcheck(var precision: integer): boolean;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

//------------------------------------------------------------------------------

// a, b, z 
// eps     l
// pre     L
// ans     
// ߂l   0  1 +  -1 -
function Confluent_Hypergeometri_of_first(aa, bb, zz: combig; eps : bigdecimal; var ans : combig): integer;
var
  a, b, z, czero, siguma, azsbnn : combig;
  az, bnn : combig;
  ap, bp, an, bn, zn : combig;
  np, nn , comabs : bigdecimal;
  n  : integer;
begin
  result := 0;
  czero.r := zero;                  // czero
  czero.i := zero;
  a := aa;                          // a
  b := bb;                          // b
  z := zz;                          // z
  ap := a;                          // (a) = a
  bp := b;                          // (b) = b
  np := one;                        // (n) = 1
  an := ap;                         // (a)n = (a);
  bn := bp;                         // (b)n = (b)
  nn := np;                         // n! = (n)
  zn := z;                          // z^n = z
  n := 1;
  siguma := czero;                  // =0
  azsbnn.r := one;
  azsbnn.i := zero;
  repeat
    az := cmul(an, zn);               // (a)n * z^n
    if caeqb(az, czero) then begin    // (a)n * z^n = 0
      comabs := zero;                 // l=0
      break;
    end;
    if caeqb(bn, czero) then begin    // (b)n = 0
      az := cmul(cmul(ap, z), azsbnn);  // (a)nz^n/(b)'n  'n=n-1 azsbnn=(a)'nz^'n/(b)'n
      if az.r >= zero then result := 1
                      else result := -1;
      break;
    end;
    bnn := cmulb(bn, nn);             // (b)n * n!

    az := combiground(az);            // precisionsɊۂ
    bnn := combiground(bnn);          // precisionsɊۂ
    azsbnn := cdiv(az, bnn);          //  = ((a)n * z^n) / ((b)n * n!)
    siguma := cadd(siguma, azsbnn);   //  = + 

    ap.r := ap.r + one;               // a=a+1
    bp.r := bp.r + one;               // b=b+1
    np := np + one;                   // n=n+1
    an := cmul(an, ap);               // (a)n
    bn := cmul(bn, bp);               // (b)n
    zn := cmul(zn, z);                // z^n
    nn := nn * np;                    // n!

    an := combiground(an);            // (a)n  precisionsɊۂ
    bn := combiground(bn);            // (b)n  precisionsɊۂ
    zn := combiground(zn);            // z^n   precisionsɊۂ
    nn := nn.RoundToPrecision(precisions);    //n!  precisionsɊۂ

    comabs := cabs(azsbnn);           // comabs = |azsbnn|
    inc(n);
  until  (comabs <= eps) or (n > 10000);
  if result <> 0 then
    ans := az
  else
    ans := caddb(siguma, one);        // =+1

  comabs := comabs.RoundToPrecision(15);
  if result = 0 then
    form1.Memo1.Lines.Append('loop = ' + inttostr(n) + ' l  ' + comabs.ToString);
end;

//------------------------------------------------------------------------------

// x <= 0   Ȃ result = true
function zeroorounderbig(xx: combig): boolean;
var
  xc : bigdecimal;
  x : combig;
begin
  // xx̒lωxx̌lsɂȂ̂ŃRs[Ďgp܂
  x := xx;

  result := false;
  if not x.i.IsZero then exit;

  // frac ΍
  x.r := x.r.RoundToPrecision(200);
  xc := x.r.Frac;
  if not xc.IsZero then exit;;
  if x.r.IsNegative or x.r.IsZero then result := true;
end;

//------------------------------------------------------------------------------

// aa, bb, zz 
// eps     l
// ans     
// ߂l   0
// }Ȃ悤bɃlZ(ɌvZ)Kv܂B
// Ȃꍇ́AlZ̕Kv܂B
function Confluent_Hypergeometri_of_second_sub(aa, bb, zz: combig; eps : bigdecimal; var ans : combig): integer;
var
  cone, ctwo, czero : combig;
  a, b, z, onemb, bmone, ambpone, twomb: combig;
  gonemb, gambpone, gbmone, ga, zhonemb: combig;
  g1, g2, m1, m2, fa, fb : combig;
begin
  a := aa;
  b := bb;
  z := zz;
  cone.r := one;                  // 1+0i
  cone.i := zero;
  ctwo := cadd(cone, cone);       // 2+0i
  czero.r := zero;                // 0+0i
  czero.i := zero;

  onemb := csub(cone, b);             // 1-b
  ambpone := cadd(csub(a, b), cone);  // a-b-1
  bmone := csub(b, cone);             // b-1
  twomb := csub(ctwo, b);             // 2-b

  // lvZ
  if not zeroorounderbig(ambpone) then begin  // not (ambpone <= 0 )
    gammabig(onemb, gonemb);                  // (1-b)
    gammabig(ambpone, gambpone);              // (a-b+1)
    gonemb := combiground(gonemb);            // precisions ۂ
    gambpone := combiground(gambpone);        // precisions ۂ
    g1 := cdiv(gonemb, gambpone);             // (1-b)/(a-b+1)
  end
  else g1 := czero;                           // ꂪ}Ȃ[

  if not zeroorounderbig(a) then begin        // not (a <= 0 )
    gammabig(bmone, gbmone);                  // (b-1)
    gammabig(a, ga);                          // (a)
    gbmone := combiground(gbmone);            // precisions ۂ
    ga := combiground(ga);                    // precisions ۂ
    g2 := cdiv(gbmone, ga);                   // (b-1)/ (a)
  end
  else g2 := czero;                           // ꂪ}Ȃ[

  // M(a,b,z) vZ
  result := Confluent_Hypergeometri_of_first(a, b, z, eps, m1);           // M1
  if result <> 0 then exit;                   // }G[I

  // M(a-b+1,2-b,z) vZ
  result := Confluent_Hypergeometri_of_first(ambpone, twomb, z, eps, m2); // M2
  if result <> 0 then exit;                   // }G[I

  // (1-b)/(a-b+1)*M(a,b,z)
  fa := cmul(g1, m1);                 // fa = g1 * m1

  zhonemb := pow_big(z, onemb, eps);  // z^(1-b)

  // (b-1)/ (a) * z^(1-b) * M(a-b+1,2-b,z)
  fb := cmul(cmul(g2, zhonemb), m2);  // fb = g2 * z^(1-b) * M2

  // (1-b)/(a-b+1)*M(a,b,z) + (b-1)/ (a) * z^(1-b) * M(a-b+1,2-b,z)
  ans := combiground(cadd(fa, fb));   // ans = fa + fb   precisions ۂ
end;

// aa, bb, zz 
// eps     l
// ans     
// ɌvZ b   a <=0 /vZ0ɂȂ̂ŁAb̂݁}ɌvZ
// ߂l 0  1 or -1 ZG[
function Confluent_Hypergeometri_of_second(aa, bb, zz: combig; eps : bigdecimal; var ans : combig): integer;
var
  a, b, z : combig;
  cone, ctwo, bpmd : combig;
  ans1, ans2 : combig;
  rfrac : bigdecimal;
  fm, f1, f2 : integer;
begin
  // }Ȃ悤ɃlZݒ(ɌvZp)
  a := aa;
  b := bb;
  z := zz;
  cone.r := one;
  cone.i := zero;
  ctwo := cadd(cone, cone);
  // b Ȃ  fm = 1  ɌvZ
  fm := 0;
  rfrac := b.r.Frac;
  if (rfrac = zero) and (b.i = zero) then fm := 1;

  f2 := 0;
  if fm <> 0 then begin                                   // } vZ
    bpmd := caddb(b, delt);           // b+b
    f1 := Confluent_Hypergeometri_of_second_sub(a, bpmd, z, eps, ans1);

    bpmd := csubb(b, delt);          // b-b
    f2 := Confluent_Hypergeometri_of_second_sub(a, bpmd, z, eps, ans2);

    ans := cdiv(cadd(ans1, ans2), ctwo);                  // (ans(+) + ans(-)) / 2
  end
  else                                                    // 
    f1 := Confluent_Hypergeometri_of_second_sub(a, b, z, eps, ans);
  result := 0;
  if (f1 <> 0) or (f2 <> 0) then result := $1;
  if fm <> 0 then result := result or $100;
end;

//------------------------------------------------------------------------------

// ͒l̍őlŏl̃`FbN
function inbigcheck(s, xtext: string): boolean;
const
  MAXSTR = '200';
  MINSTR = '1e-100';
var
  max, min, x: bigdecimal;
begin
  result := false;
  try
    x := xtext;
  except
    on EConverterror do begin
      MessageDlg(s + ' ̒lɊԈႢ܂B', mtError, [mbOK], 0);
//      application.MessageBox(pchar(s + ' ̒lɊԈႢ܂B'),'G[', 0);
      exit;
    end;
  end;
  max := MAXSTR;
  min := MinSTR;
  if x.Abs(x) > max then begin
    application.MessageBox(pchar('abs(' + s + ')̒l傫܂B' + #13#10 +
                                              '}' + MAXSTR + 'xłB'),'',0);
    exit;
  end;
  if (x.Abs(x) < min) and (x.Abs(x) <> zero) then begin
    application.MessageBox(pchar('abs(' + s + ')̒l܂B' + #13#10 +
                                              '}' + MINSTR + 'xłB'),'',0);
    exit;
  end;
  result := true;
end;

// ̓`FbN
function TForm1.inputcheck(var precision: integer): boolean;
const
  DMIN = '1e-100';
  DMAX = '1e-10';
var
  chd: double;
  ch : integer;
  deltmax, deltmin : bigdecimal;
begin
  result := false;
  if not inbigcheck('a ', aedit.Text) then exit;;
  if not inbigcheck('b ', bedit.Text) then exit;;
  if not inbigcheck('z ', zedit.Text) then exit;;
  if not inbigcheck('a̋', iaedit.Text) then exit;;
  if not inbigcheck('b̋', ibedit.Text) then exit;;
  if not inbigcheck('z̋', izedit.Text) then exit;;
  try
    delt := deltedit.Text;
  except
    on EConverterror do begin
      application.MessageBox(pchar(' ̒lɊԈႢ܂B'), nil);
      exit;
    end;
  end;
  deltmin := DMIN;
  deltmax := DMAX;
  if delt > deltmax then begin
    application.MessageBox('l 1e-10 菬ĉB','',0);
    exit;
  end;
  if delt < deltmin then begin
    application.MessageBox('l 1e-100 傫ĉB','',0);
    exit;
  end;
  val(precisionedit.Text, precision, ch);
  if ch <> 0 then begin
    application.MessageBox('L ̒lɊԈႢ܂B','',0);
    exit;
  end;
  if precision < 10 then begin
    application.MessageBox('L 10ȏɂĉB','',0);
    exit;
  end;
  if precision > 1000 then begin
    application.MessageBox('L 1000ȉɂĉB','',0);
    exit;
  end;
  val(epsedit.Text, chd, ch);
  if ch <> 0 then begin
    application.MessageBox('lɊԈႢ܂B','',0);
    exit;
  end;
  if chd < 1e-100 then begin
    application.MessageBox('l1e-100傫ĉB','',0);
    exit;
  end;
  if chd > 1e-1 then begin
    application.MessageBox('l1e-1菬B','',0);
    exit;
  end;
  result := true;
end;

//------------------------------------------------------------------------------

// ľ̃[
function ZeroErase(s : string): string;
const
  EP = 'e';
  ZC = '0';
  dt = '.';
var
  c : char;
  i, j, k, l : integer;
begin
  l := length(s);                   // l
  j := 1;                           // j=1
  for i := 1 to l do begin          // ꕶڂ
    c := s[i];                        // ꕶo
    if c = EP then begin              // 'e'
      j := i - 1;                       // ȇO̕No
      break;                            // u[N
    end;
    j := i;                         // 'e'Ȃj=i
  end;
  result := '';                     // ''ݒ
  if j < l then begin               // j菬
    for i := l downto j + 1 do        // ̌납
      result := s[i] + result;          // 'e'Rs[
  end;
  K := 1;                           // k=1
  for i := j downto 1 do begin        // 'e'̑O̕
    c := s[i];                        // ꕶo'0'͓ǂݔ΂
    if c <> ZC then begin             // '0'Ŗ
      k := i;                           // k=i
      if c = DT then k := k + 1;        // '.' k=i+1 '.'̌'0'͎c
      break;                            // u[N
    end;
  end;
  for i := k downto 1 do            // k1ڂ܂ŃRs[
    result := s[i] + result;          // OɒǉRs[
end;

//------------------------------------------------------------------------------

// \ݒ
function roundNumber(rn: string): integer;
const
  MS = '-';
var
  leng, i : integer;
  str : string;
  ch : char;
  lm, ll : double;
begin
  str := '';                            // ''
  leng := length(rn);                   //   '1e-nn'
  result := 0;
  for i := leng downto 1 do begin       // 납 '-'̌̕o
    ch := rn[i];                        // 1o
    if ch = MS then begin               // '-'
      result := strtoint(str);          // lɕϊ
      break;                            // u[N
    end;
    str := ch + str;                    // Oɕǉ
  end;
  if result = 0 then begin              // -'
    lm := strtofloat(rn);               // lɕϊ im
    result := 0;                        // 1
    ll := 1;                            // ll=1
    repeat
      ll := ll / 10;                    // ll<=im ܂10ŏZ
      inc(result);                      // result := result + 1
    until ll < lm;
    dec(result);                        // result := result - 1
  end;
  if result > 50 then result := 50;
end;

// vZ
procedure TForm1.CalcBtnClick(Sender: TObject);
const
  ZE = '1e-55';                                 // [l
var
  a, b, z, ans : combig;
  eps : bigdecimal;
  f1 : integer;
  absans, zem, tmb : bigdecimal;
begin
  if inputcheck(precisions) = false then exit;  // ͒l`FbN
  bigdecimal.DefaultPrecision := precisions;    // L
  a.r := aedit.Text;                            // a.re
  a.i := iaedit.Text;                           // a.im
  b.r := bedit.Text;                            // b.re
  b.i := ibedit.Text;                           // b.im
  z.r := zedit.Text;                            // z.re
  z.i := izedit.Text;                           // z/im
  eps := epsedit.Text;                          // l
  zem := ZE;                                    // [l
  tmb := delt / eps;                            // / l
  if tmb < 10 then begin
    application.MessageBox('l̓l101ȉɂĂB','',0);
  end;

  memo1.Clear;
  memo1.Lines.Append('P퍇^􉽊֐ M(a,b,z)');
  f1 := Confluent_Hypergeometri_of_first(a, b, z, eps, ans);

  if f1 = 0 then begin
    ans.r := ans.r.RoundToPrecision(60);
    ans.i := ans.i.RoundToPrecision(60);

    memo1.Lines.Append(' (60\)');
    memo1.Lines.Append(' (' + ans.r.ToString + ')');
    memo1.Lines.Append(' (' + ans.i.ToString + ' i' + ')');

    absans := absans.Abs(ans.r);
    if absans < zem then ans.r := zero;
    absans := absans.Abs(ans.i);
    if absans < zem then ans.i := zero;

    ans.r := ans.r.RoundToPrecision(roundNumber(epsedit.Text));
    ans.i := ans.i.RoundToPrecision(roundNumber(epsedit.Text));

    memo1.Lines.Append('ans ' + intTostr(roundNumber(epsedit.Text)) + 'Ɋۂ');
    if ans.r = zero then
      memo1.Lines.Append(' 0.0')
    else
      memo1.Lines.Append(ZeroErase(' ' + ans.r.ToString));
    if ans.i = zero then
      memo1.Lines.Append(' 0.0 i')
    else
      memo1.Lines.Append(ZeroErase(' ' + ans.i.ToString) + ' i');
  end
  else begin
    memo1.Lines.Append('ans');
    if ans.r > zero then memo1.Lines.Append(' ');
    if ans.r < zero then memo1.Lines.Append(' -');
    if ans.i > zero then memo1.Lines.Append(' + i');
    if ans.i < zero then memo1.Lines.Append(' - i');
  end;

  memo1.Lines.Append('');
  memo1.Lines.Append('Q퍇^􉽊֐ U(a,b,z)');
  f1 := Confluent_Hypergeometri_of_second(a, b, z, eps, ans);
  // Q퍇^􉽊֐͕K̂Ł}͔܂AÖׁB
  if f1 and $1 <> 0 then begin
    memo1.Lines.Append('} ZG[');
    exit;
  end;

  ans.r := ans.r.RoundToPrecision(60);
  ans.i := ans.i.RoundToPrecision(60);

  memo1.Lines.Append(' (60\)');
  memo1.Lines.Append(' (' + ans.r.ToString + ')');
  memo1.Lines.Append(' (' + ans.i.ToString + ' i' + ')');

  if f1 and $100 = 0 then
    memo1.Lines.Append('ans ' + intTostr(roundNumber(epsedit.Text)) + 'Ɋۂ')
  else
    memo1.Lines.Append('ans ' + intTostr(roundNumber(epsedit.Text)) + 'Ɋۂ  ɌlvZ ');

  ans.r := ans.r.RoundToPrecision(roundNumber(epsedit.Text));
  ans.i := ans.i.RoundToPrecision(roundNumber(epsedit.Text));
  absans := absans.Abs(ans.r);
  if absans < zem then ans.r := zero;
  absans := absans.Abs(ans.i);
  if absans < zem then ans.i := zero;

  if ans.r = zero then
    memo1.Lines.Append(' 0.0')
  else
    memo1.Lines.Append(ZeroErase(' ' + ans.r.ToString));
  // Ō̍s͉sȂ
  if ans.i = zero then
    memo1.Text := memo1.Text + ' 0.0 i'
  else
    memo1.Text := memo1.Text + ZeroErase(' ' + ans.i.ToString) + ' i ';
end;

//------------------------------------------------------------------------------

// ftHglɐݒ
procedure TForm1.BitBtn1Click(Sender: TObject);
begin
  deltedit.Text := DELTB;
  epsedit.Text := EPS;
end;


//------------------------------------------------------------------------------

// ݒ
procedure TForm1.FormCreate(Sender: TObject);
begin
  precisionedit.Text := intTostr(DPS);
  deltedit.Text := DELTB;
  memo1.Clear;
end;

end.
